Introdução

GraphData 1.0

Freeware

http://www.sgrillo.net

Introdução

Nas atividades de pesquisa científica muitas vezes os pesquisadores só encontram disponíveis os dados que necessita em forma gráfica, tendo que utilizar a régua e o lápis para estimar os valores numéricos de cada ponto no gráfico.

GraphData foi desenvolvido para extrair automaticamente dados numéricos de gráficos disponíveis em forma de Imagem (bmp, gif, jpg, etc), facilitando o trabalho de extração dos dados numéricos e aumentando sua precisão.

Inicialmente deve ser carregada a figura com o gráfico no programa. Quando necessário esta figura poderá ser editada, para otimizar a extração dos dados, com utilização do editor de imagens disponível no programa.

O princípios de extração dos dados é simples: o programa percorre a figura no sentido vertical, medindo a distancia do topo (ou da base) até a linha do gráfico. Através dos valores máximos e mínimos informados para os eixos X e Y o programa gera os valores numérico de cada ponto (X, Y), ao longo da linha do gráfico, na escala correspondente a utilizada na figura original.

O aplicativo encontra a linha do gráfico através de sua cor, que deve ser indicada pelo usuário previamente. Por esse motivo não podem aparecer na figura texto ou outros elementos gráficos que tenham a mesma cor da linha do gráfico. Também por este motivo é possível extrair dados de diferentes gráficos na mesma figura, desde que a cor de cada linha seja diferente.

Os dados gerados podem ser gravados, copiados ou exportados para o MS Excel®.

Suporte: ricardo.sgrillo@terra.com.br

Copyright © 2008, Ricardo Sgrillo

This help file has been generated by the freeware version of HelpNDoc


Carregando e preparando a figura

Carregando a figura

Carregando a figura

A figura com o gráfico pode ser carregada clicando-se nos itens Abrir gráfico ou Colar gráfico no menu Arquivo.

A figura será aberta ou colada no seu tamanho original, embora seja mostrada em tamanho constante (760 x 500 pixels) na janela do aplicativo.

Figura 1. Tela apresentada após carregar a figura.

Um gráfico como o mostrado na figura 1 não é adequado para extração dos dados uma vez que não é possível o programa identificar os valores numéricos utilizados nas escalas do gráfico.

Neste caso, o gráfico deverá ser preparado adequadamente, conforme descrito a seguir.

A barra de ferramentas poderá ser arrastada com o mouse e reposicionada em qualquer lugar do formulário.

A Figura poderá ser reposicionada sendo arrastada com o botão direito do mouse, enquanto Ctrl é pressionado.

Preparando a gráfico

O gráfico deverá ser preparado considerando-se as observações abaixo. A preparação poderá ser feita externamente, com qualquer editor de imagens (Paint, Corel, ETC), ou utilizando-se o editor disponível no programa.

Para facilitar a edição está disponível, no menu Ver e Janela Zoom, uma pequena lente de aumento que pode ser arrastada para qualquer ponto da figura.

Figura 1A. Janela Zoom

O editor do programa é aberto clicando-se no menu Editar em Editar gráfico. Para concluir a edição deve se clicar no menu Editar em Extrair números.

Quando o editor é aberto a figura é mostrada no seu tamanho original. A janela do programa pode ser maximizada para conter toda a figura, mas figuras maiores que a tela do computador não poderão ser mostradas e editadas na sua totalidade. Estas figuras poderão ser editadas com um editor externo e então coladas no programa.

A barra de ferramentas poderá ser arrastada com o mouse e reposicionada em qualquer lugar do formulário.

A Figura poderá ser reposicionada sendo arrastada com o botão direito do mouse, enquanto Ctrl é pressionado.

A barra de ferramentas do menu Editar gráfico é mostrada abaixo.

Figura 2. Barra de ferramentas no modo de edição

a) Tamanho

A figura com o gráfico deverá ser recortada, se for necessário, para conter somente a área delimitada pelos valores mínimos e máximos dos eixos X e Y,

A

B

Figura 3. A - Figura original; B - Figura recortada para conter somente a área delimitada pelos valores mínimos e máximos dos eixos X e Y,

Para recortar (crop) a figura clique na ferramenta Recortar (Ver Fig 2) e depois clique no canto superior esquerdo da área a ser recortada e arraste o mouse até o canto inferior direito e solte o botão. Quando o botão for solto o gráfico será recortado conforme mostrado na Figura 3-B

Se for necessário use a ferramenta Linha para marcar a área a ser recortada desenhando as linhas correspondentes. Utilize uma cor diferente da das linhas e pontos do gráfico.

Não esqueça de anotar os valores máximos e mínimos das escalas de X e Y nos campos apropriados da barra de ferramentas para que os dados extraídos sejam apresentados na escala original da figura.

b) Falhas na figura

Use as ferramentas Desenhar ou Linha, para corrigir falhas nas linhas do gráfico.

A largura do desenho e da linha pode ser escolhida no slider Largura linha/borracha, na barra de ferramentas.

Clique na ferramenta Picker (conta gotas) e em cima da linha do gráfico para selecionar a cor da linha.

Clique duplo na caixa Cor para escolher qualquer cor

b) Elementos adicionais na figura

Elementos gráficos, como linhas e textos que aparecem em legendas por exemplo, podem permanecer na área do gráfico desde que não tenham a mesma cor das linhas do gráfico das quais se quer extrair os dados. Se possuírem a mesma cor devem ser apagados com a ferramenta Apagar na barra de ferramentas.

A largura da ferramenta Apagar pode ser escolhida no slider Largura linha/borracha, na barra de ferramentas.

Encerrando a preparação

Quando terminar de editar a figura clicar em Extrair números no menu Editar. Este procedimento fixara as alterações na figura e passará ao modo de extração dos dados. É possível voltar ao modo de edição em qualquer instante.

Copyright © 2008, Ricardo Sgrillo

This help file has been generated by the freeware version of HelpNDoc


Extraindo os dados

Extraindo os dados

Se a imagem carregada inicialmente for adequada ou se já tiver sido editada pode se passar então para a etapa de extração dos dados propriamente dita.

Figura 4. Tela de extração dos dados

Figura 5. Barra de ferramentas para extração dos dados.

a) Escolhendo a cor

Para facilitar a seleção da cor está disponível, no menu Ver e Janela Zoom, uma pequena lente de aumento que pode ser arrastada para qualquer ponto da figura.

Clique em uma das linhas ou pontos do gráfico, ou da janela zoom, para selecionar a cor correspondente. A cor selecionada aparecerá na barra de ferramentas.

Em muitas imagens, especialmente em meio-tom, do tipo jpg, os elementos gráficos são apresentados em pixels com diferentes tonalidades da mesma cor. Neste caso pode ser aumentada a tolerância de identificação da cor, deslizando-se o slider correspondente para a direita (ver Fig 5.)

Em outros casos a figura pode apresentar múltiplos gráficos, com linhas de cor semelhante. Neste caso pode ser necessário reduzir a tolerância de identificação da cor para que não haja interferência entre as linhas.

b) Escalas

Os valores mínimos e máximos para as escalas deverão ser escolhidos de acordo com a área que será utilizada para a extração dos valores.

A B

Figura 6. Escolhendo a escala. Linhas pontilhadas indicam onde a figura será recortada

Na Fig. 6, por exemplo, para extrair números mantendo a escala original os valores mínimos e máximos de X a ser escolhidos seriam 1999 e 2005, respectivamente e de Y que seriam 364 e 376, respectivamente (pontos a, b, c, d).

Adicionalmente deve ser informado se o valor máximo da escala Y (376 no caso) corresponde a altura da figura, como mostrado na figura 6 A, ou se o valor máximo informado corresponde ao valor máximo da linha do gráfico, conforme a figura 6B. Neste caso o valor máximo da escala de X informado deveria ser 375 (pontos a, b).

Também pode ser informado o numero desejado de pontos para leitura da linha no eixo X. Como padrão o programa acha os valores da escala Y para cada pixel na escala X. O numero de pixels existentes é apresentado no campo N. Pontos X na barra de ferramentas (ver fig. 5). No exemplo apresentado na figura 5 existem 795 pixels, o que significa que seriam extraídos 795 pares de pontos x, y. Se o gráfico tiver uma variação suave pode não ser necessário um numero elevado de pontos. Neste caso o usuário pode escolher quantos pontos deseja utilizar na extração dos dados.

b) Métodos

O usuário pode escolher três métodos para a extração dos dados.

No método para cima (seta para cima na figura 5) o programa parte da base da figura e vai subindo verticalmente, analisando a cor de cada pixel da figura. Quando encontra um pixel com cor igual a selecionada (considerando a tolerância) os valores vertical e horizontal (Y e X) são armazenados.

No método para baixo (seta para baixo na figura 5) o programa parte do topo da figura e vai descendo verticalmente, analisando a cor de cada pixel da figura. Quando encontra um pixel com cor igual a selecionada (considerando a tolerância) os valores vertical e horizontal (Y e X) são armazenados.

No método central o programa utiliza a média dos valores dos métodos para cima e para baixo. O método central é especialmente adequado quando a linha do gráfico tem vários pixels de espessura.

Na barra de ferramentas também podem ser escolhido o numero de casas decimais e aplicação de notação científica para a apresentação dos resultados.

c) Extração

Para extrair os dados clique no menu Run. Conforme o programa vai extraindo os dados a linha do gráfico vai sendo substituída por pequenos círculos com a cor complementar.

Gráficos múltiplos

Se a figura for composta por múltiplos gráficos que compartilham a mesma escala, como apresentado na figura 4, o processo de extraç~~ao de todos os gráficos seria o seguinte:

1. Informar os dados de escala, método, decimais, etc.

2. Clicar em uma das linhas ou pontos para informara a cor

3. Clicar no menu Run

O programa vai marcando a linha escolhida e quando chegar ao fim apresenta uma tabela com os valores extraídos de X e Y

4. No menu Ver clicar em Gráfico para voltar a apresentar a figura

5. Na barra de ferramentas cheque o controle Agregar

6. Clicar na próxima linha do gráfico para informar a cor

7. Clicar em Run

8. Voltar ao ponto 4 conforme necessário

Copyright © 2008, Ricardo Sgrillo

This help file has been generated by the freeware version of HelpNDoc


Verificando os resultados

Verificando os resultados

Após a extração os dados são apresentados automaticamente em uma tabela, conforme figura 7. Para voltar a apresentar a figura do gráfico com marcação dos pontos de onde foram extraídos dados clicar no menu Ver e em Gráfico.

Está tabela poderá ser exportada para o MS Excel, gravada com arquivo de texto separado por vírgula ou copiado para o clipboard, de onde poderá ser colado em outros aplicativos. Escolha a opção desejada no menu Arquivo.

Figura 7. Tabela de apresentação dos dados extraídos de dois gráficos na mesma figura (ver Fig.. 4)

Em função da qualidade da figura original os resultados obtidos podem não ser satisfatórios requerendo um ajusto mais preciso na tolerância de cor escolhida. A figura poderá também ser editada novamente, para reforçar linhas apagadas, apagar elementos gráficos adicionais, etc.

A figura 8 B mostra um exemplo no qual a tolerância de cor foi fixada em um valor muito baixo. Neste caso pontos importantes do gráfico não foram reconhecidos como pertencentes a linha do gráfico e alguns valores de pico, por exemplo, foram perdidos. Este problema poderia ser solucionada aumentando-se a tolerância de cor ou editando o gráfico e reforçando os partes não reconhecidas.

Na figura 8 C a tolerância escolhida foi muito elevada e pontos não pertencentes a linha do gráfico foram erroneamente reconhecidos. Neste caso a solução seria diminuir a tolerância ou editar o gráfico e apagar os elementos não pertencentes a linha do gráfico.

Figura 8. A-Gráfico original de onde os dados forma extraídos; B- Pontos (círculos verdes) assinalando as coordenadas correspondentes a extração dos dados quando a tolerância de cor foi fixada no seu valor mínimo; C-Pontos correspondentes a tolerância de cor fixada no seu valor máximo.

Copyright © 2008, Ricardo Sgrillo

This help file has been generated by the freeware version of HelpNDoc